#!/usr/bin/python
#coding: utf-8
#-----------------------------
# 安装脚本
#-----------------------------

import sys,os,shutil
panelPath = os.getenv('BT_PANEL')
os.chdir(panelPath)
sys.path.append("class/")
import public,tarfile,json

class panel_memcached:
    _name = 'memcached'
    _version = None
    _setup_path = None

    def __init__(self,name,version,setup_path): 
        self._version = version
        self._setup_path = setup_path
    
    def install_soft(self,downurl):
        if public.get_server_status(self._name) >= 0:  public.delete_server(self._name)

        temp = self._setup_path + '/temp/memcached.rar'
        public.downloadFile(downurl + '/win/memcached/memcached' + self._version + '.rar',temp)
        if not os.path.exists(temp): return public.returnMsg(False,'文件下载失败,请检查网络!');

        from unrar import rarfile
        rar = rarfile.RarFile(temp)  
        rar.extractall(self._setup_path)

        rRet = public.create_server(self._name,self._name,self._setup_path + '\\memcached\\memcached_server.exe','',"Memcached 是一个高性能的分布式内存对象缓存系统，用于动态Web应用以减轻数据库负载")
        if public.get_server_status(self._name) == 0:
            if public.set_server_status(self._name,'start'): 
                public.bt_print('memcached启动成功.')
            else:
                return public.returnMsg(False,'启动失败，请检查配置文件是否错误!');

        config_path = self._setup_path + '/memcached/config.json'
        data = {}
        data['bind'] = '-l 127.0.0.1'
        data['port']  = '-p 11211'
        data['cachesize'] = '-m 128'
        data['minsize'] = '-n 48'
        data['maxconn'] = '-c 2048'
        data['factor'] = '-f 1.25'

        public.writeFile(self._setup_path + '/memcached/runservice','-l 127.0.0.1 -p 11211 -m 128 -n 48 -f 1.25 -c 2048')
        public.writeFile(config_path,json.dumps(data))
        public.bt_print('memcached安装成功.')
        return public.returnMsg(True,'安装成功!');
        return rRet;

    def uninstall_soft(self):
        if public.get_server_status(self._name) >= 0:  
            public.delete_server(self._name)

        return public.returnMsg(True,'卸载成功!');

    def update_soft(self,downurl):
        path = self._setup_path + '/memcached'
        sfile = path +'/config.json'
        dfile = path + '/config.json.backup'
        shutil.copy (sfile,dfile)
        rRet = self.install_soft(downurl)
        if not rRet['status'] : rRet;
        if public.set_server_status(self._name,'stop'):
            shutil.copy (dfile,sfile)
            os.remove(dfile);
            if public.set_server_status(self._name,'start'):
                 return public.returnMsg(True,'更新成功!');
        return public.returnMsg(False,'更新失败!');



